/*C Program 6   CSCI 2320.003
  Scott Dudley  baz006

  A C program that accepts characters entered by the user
  until he presses the Enter key.

*/

#include  <stdio.h>
#include  <ctype.h>
#include  "course.h"


/*DispCharInfo displays all the information about one character*/
void DispCharInfo(unsigned char inkey,int count)
 {
 unsigned char mask, loopvar,tempchar;

 /*Character and position*/
 printf("Character %2i: '%c' ",count,inkey);

 /*binary form*/
 mask=0x80; /*bin 10000000*/
 for (loopvar=1;loopvar<=8;loopvar++)
  {
   if ((inkey & mask)==mask)
    printf("1");
   else
    printf("0");
   mask >>= 1;
  }

  /*Hex form. I beleive there was a much easier way to do this,
    but I'm just not sure what it was. This way is very effective.*/
 printf(" %c%c ",
 ((inkey>>4)    >0x09) ? (inkey>>4    )+64-0x09 : (inkey>>4    )+0x30,
 ((inkey & 0x0f)>0x09) ? (inkey & 0x0f)+64-0x09 : (inkey & 0x0f)+0x30);

 /*Decimal format. Pretty simple stuff*/
 printf("%3i ",inkey);


 /*description of the nature of the character*/
 if (inkey >='A' && inkey <='Z')
  {
   printf("Uppercase Letter");
   switch (inkey)
    {
     case 'A' : case 'E' : case 'I' : case 'O' : case 'U' :
     printf(" (Vowel");break;
     default : printf(" (Consonant)");
    }
  }
 else if (inkey >= 'a' && inkey <= 'z')
  {
   printf("Lowercase Letter");
   switch (inkey)
    {
     case 'a' : case 'e' : case 'i' : case 'o' : case 'u' :
     printf(" (Vowel");break;
     default : printf(" (Consonant)");
    }
  }
 else if (inkey >= '0' && inkey <= '9')
  printf("Digit");
 else if (inkey == ' ')
  printf("Space");
 else
  printf("Other");
 printf("\n");
 }


void main()
{
 unsigned char inkey,dump;
 int count;
  do
   {
    clrscr();
    printf("Scott Dudley     Program 6     CSCI 2320.003     baz006\n\n");
    printf("Enter characters: ");

    count=0;
    while ((inkey=getchar()) != '\n')
     {
      if (count==0) printf("\n");
      count++;
      DispCharInfo(inkey,count);
     }

    printf("\nWould like to continue? (y/N) ");
    inkey=getchar();
    if (inkey!='\n')
     while (( dump=getchar() ) != '\n') ;

    }
  while (toupper(inkey)=='Y');
 }

